/*
 *
 * Copyright 2020 AT&T Intellectual Property
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */

/*
 * Generated by asn1c-0.9.29 (http://lionet.info/asn1c)
 * From ASN.1 module "E2SM-gNB-NRT-IEs"
 * 	found in "../asnTextFiles/e2sm-gNB-NRT-v401.asn"
 * 	`asn1c -fcompound-names -fincludes-quoted -fno-include-deps -findirect-choice -gen-PER -no-gen-OER -D.`
 */

#include "E2SM-gNB-NRT-RANfunction-Definition.h"

#include "RIC-EventTriggerStyle-List.h"
#include "RIC-ReportStyle-List.h"
#include "RIC-InsertStyle-List.h"
#include "RIC-ControlStyle-List.h"
#include "RIC-PolicyStyle-List.h"
static int
memb_ric_EventTriggerStyle_List_constraint_1(const asn_TYPE_descriptor_t *td, const void *sptr,
			asn_app_constraint_failed_f *ctfailcb, void *app_key) {
	size_t size;
	
	if(!sptr) {
		ASN__CTFAIL(app_key, td, sptr,
			"%s: value not given (%s:%d)",
			td->name, __FILE__, __LINE__);
		return -1;
	}
	
	/* Determine the number of elements */
	size = _A_CSEQUENCE_FROM_VOID(sptr)->count;
	
	if((size >= 1 && size <= 63)) {
		/* Perform validation of the inner elements */
		return td->encoding_constraints.general_constraints(td, sptr, ctfailcb, app_key);
	} else {
		ASN__CTFAIL(app_key, td, sptr,
			"%s: constraint failed (%s:%d)",
			td->name, __FILE__, __LINE__);
		return -1;
	}
}

static int
memb_ric_ReportStyle_List_constraint_1(const asn_TYPE_descriptor_t *td, const void *sptr,
			asn_app_constraint_failed_f *ctfailcb, void *app_key) {
	size_t size;
	
	if(!sptr) {
		ASN__CTFAIL(app_key, td, sptr,
			"%s: value not given (%s:%d)",
			td->name, __FILE__, __LINE__);
		return -1;
	}
	
	/* Determine the number of elements */
	size = _A_CSEQUENCE_FROM_VOID(sptr)->count;
	
	if((size >= 1 && size <= 63)) {
		/* Perform validation of the inner elements */
		return td->encoding_constraints.general_constraints(td, sptr, ctfailcb, app_key);
	} else {
		ASN__CTFAIL(app_key, td, sptr,
			"%s: constraint failed (%s:%d)",
			td->name, __FILE__, __LINE__);
		return -1;
	}
}

static int
memb_ric_InsertStyle_List_constraint_1(const asn_TYPE_descriptor_t *td, const void *sptr,
			asn_app_constraint_failed_f *ctfailcb, void *app_key) {
	size_t size;
	
	if(!sptr) {
		ASN__CTFAIL(app_key, td, sptr,
			"%s: value not given (%s:%d)",
			td->name, __FILE__, __LINE__);
		return -1;
	}
	
	/* Determine the number of elements */
	size = _A_CSEQUENCE_FROM_VOID(sptr)->count;
	
	if((size >= 1 && size <= 63)) {
		/* Perform validation of the inner elements */
		return td->encoding_constraints.general_constraints(td, sptr, ctfailcb, app_key);
	} else {
		ASN__CTFAIL(app_key, td, sptr,
			"%s: constraint failed (%s:%d)",
			td->name, __FILE__, __LINE__);
		return -1;
	}
}

static int
memb_ric_ControlStyle_List_constraint_1(const asn_TYPE_descriptor_t *td, const void *sptr,
			asn_app_constraint_failed_f *ctfailcb, void *app_key) {
	size_t size;
	
	if(!sptr) {
		ASN__CTFAIL(app_key, td, sptr,
			"%s: value not given (%s:%d)",
			td->name, __FILE__, __LINE__);
		return -1;
	}
	
	/* Determine the number of elements */
	size = _A_CSEQUENCE_FROM_VOID(sptr)->count;
	
	if((size >= 1 && size <= 63)) {
		/* Perform validation of the inner elements */
		return td->encoding_constraints.general_constraints(td, sptr, ctfailcb, app_key);
	} else {
		ASN__CTFAIL(app_key, td, sptr,
			"%s: constraint failed (%s:%d)",
			td->name, __FILE__, __LINE__);
		return -1;
	}
}

static int
memb_ric_PolicyStyle_List_constraint_1(const asn_TYPE_descriptor_t *td, const void *sptr,
			asn_app_constraint_failed_f *ctfailcb, void *app_key) {
	size_t size;
	
	if(!sptr) {
		ASN__CTFAIL(app_key, td, sptr,
			"%s: value not given (%s:%d)",
			td->name, __FILE__, __LINE__);
		return -1;
	}
	
	/* Determine the number of elements */
	size = _A_CSEQUENCE_FROM_VOID(sptr)->count;
	
	if((size >= 1 && size <= 63)) {
		/* Perform validation of the inner elements */
		return td->encoding_constraints.general_constraints(td, sptr, ctfailcb, app_key);
	} else {
		ASN__CTFAIL(app_key, td, sptr,
			"%s: constraint failed (%s:%d)",
			td->name, __FILE__, __LINE__);
		return -1;
	}
}

static asn_per_constraints_t asn_PER_type_ric_EventTriggerStyle_List_constr_3 CC_NOTUSED = {
	{ APC_UNCONSTRAINED,	-1, -1,  0,  0 },
	{ APC_CONSTRAINED,	 6,  6,  1,  63 }	/* (SIZE(1..63)) */,
	0, 0	/* No PER value map */
};
static asn_per_constraints_t asn_PER_type_ric_ReportStyle_List_constr_5 CC_NOTUSED = {
	{ APC_UNCONSTRAINED,	-1, -1,  0,  0 },
	{ APC_CONSTRAINED,	 6,  6,  1,  63 }	/* (SIZE(1..63)) */,
	0, 0	/* No PER value map */
};
static asn_per_constraints_t asn_PER_type_ric_InsertStyle_List_constr_7 CC_NOTUSED = {
	{ APC_UNCONSTRAINED,	-1, -1,  0,  0 },
	{ APC_CONSTRAINED,	 6,  6,  1,  63 }	/* (SIZE(1..63)) */,
	0, 0	/* No PER value map */
};
static asn_per_constraints_t asn_PER_type_ric_ControlStyle_List_constr_9 CC_NOTUSED = {
	{ APC_UNCONSTRAINED,	-1, -1,  0,  0 },
	{ APC_CONSTRAINED,	 6,  6,  1,  63 }	/* (SIZE(1..63)) */,
	0, 0	/* No PER value map */
};
static asn_per_constraints_t asn_PER_type_ric_PolicyStyle_List_constr_11 CC_NOTUSED = {
	{ APC_UNCONSTRAINED,	-1, -1,  0,  0 },
	{ APC_CONSTRAINED,	 6,  6,  1,  63 }	/* (SIZE(1..63)) */,
	0, 0	/* No PER value map */
};
static asn_per_constraints_t asn_PER_memb_ric_EventTriggerStyle_List_constr_3 CC_NOTUSED = {
	{ APC_UNCONSTRAINED,	-1, -1,  0,  0 },
	{ APC_CONSTRAINED,	 6,  6,  1,  63 }	/* (SIZE(1..63)) */,
	0, 0	/* No PER value map */
};
static asn_per_constraints_t asn_PER_memb_ric_ReportStyle_List_constr_5 CC_NOTUSED = {
	{ APC_UNCONSTRAINED,	-1, -1,  0,  0 },
	{ APC_CONSTRAINED,	 6,  6,  1,  63 }	/* (SIZE(1..63)) */,
	0, 0	/* No PER value map */
};
static asn_per_constraints_t asn_PER_memb_ric_InsertStyle_List_constr_7 CC_NOTUSED = {
	{ APC_UNCONSTRAINED,	-1, -1,  0,  0 },
	{ APC_CONSTRAINED,	 6,  6,  1,  63 }	/* (SIZE(1..63)) */,
	0, 0	/* No PER value map */
};
static asn_per_constraints_t asn_PER_memb_ric_ControlStyle_List_constr_9 CC_NOTUSED = {
	{ APC_UNCONSTRAINED,	-1, -1,  0,  0 },
	{ APC_CONSTRAINED,	 6,  6,  1,  63 }	/* (SIZE(1..63)) */,
	0, 0	/* No PER value map */
};
static asn_per_constraints_t asn_PER_memb_ric_PolicyStyle_List_constr_11 CC_NOTUSED = {
	{ APC_UNCONSTRAINED,	-1, -1,  0,  0 },
	{ APC_CONSTRAINED,	 6,  6,  1,  63 }	/* (SIZE(1..63)) */,
	0, 0	/* No PER value map */
};
static asn_TYPE_member_t asn_MBR_ric_EventTriggerStyle_List_3[] = {
	{ ATF_POINTER, 0, 0,
		(ASN_TAG_CLASS_UNIVERSAL | (16 << 2)),
		0,
		&asn_DEF_RIC_EventTriggerStyle_List,
		0,
		{ 0, 0, 0 },
		0, 0, /* No default value */
		""
		},
};
static const ber_tlv_tag_t asn_DEF_ric_EventTriggerStyle_List_tags_3[] = {
	(ASN_TAG_CLASS_CONTEXT | (1 << 2)),
	(ASN_TAG_CLASS_UNIVERSAL | (16 << 2))
};
static asn_SET_OF_specifics_t asn_SPC_ric_EventTriggerStyle_List_specs_3 = {
	sizeof(struct E2SM_gNB_NRT_RANfunction_Definition__ric_EventTriggerStyle_List),
	offsetof(struct E2SM_gNB_NRT_RANfunction_Definition__ric_EventTriggerStyle_List, _asn_ctx),
	0,	/* XER encoding is XMLDelimitedItemList */
};
static /* Use -fall-defs-global to expose */
asn_TYPE_descriptor_t asn_DEF_ric_EventTriggerStyle_List_3 = {
	"ric-EventTriggerStyle-List",
	"ric-EventTriggerStyle-List",
	&asn_OP_SEQUENCE_OF,
	asn_DEF_ric_EventTriggerStyle_List_tags_3,
	sizeof(asn_DEF_ric_EventTriggerStyle_List_tags_3)
		/sizeof(asn_DEF_ric_EventTriggerStyle_List_tags_3[0]) - 1, /* 1 */
	asn_DEF_ric_EventTriggerStyle_List_tags_3,	/* Same as above */
	sizeof(asn_DEF_ric_EventTriggerStyle_List_tags_3)
		/sizeof(asn_DEF_ric_EventTriggerStyle_List_tags_3[0]), /* 2 */
	{ 0, &asn_PER_type_ric_EventTriggerStyle_List_constr_3, SEQUENCE_OF_constraint },
	asn_MBR_ric_EventTriggerStyle_List_3,
	1,	/* Single element */
	&asn_SPC_ric_EventTriggerStyle_List_specs_3	/* Additional specs */
};

static asn_TYPE_member_t asn_MBR_ric_ReportStyle_List_5[] = {
	{ ATF_POINTER, 0, 0,
		(ASN_TAG_CLASS_UNIVERSAL | (16 << 2)),
		0,
		&asn_DEF_RIC_ReportStyle_List,
		0,
		{ 0, 0, 0 },
		0, 0, /* No default value */
		""
		},
};
static const ber_tlv_tag_t asn_DEF_ric_ReportStyle_List_tags_5[] = {
	(ASN_TAG_CLASS_CONTEXT | (2 << 2)),
	(ASN_TAG_CLASS_UNIVERSAL | (16 << 2))
};
static asn_SET_OF_specifics_t asn_SPC_ric_ReportStyle_List_specs_5 = {
	sizeof(struct E2SM_gNB_NRT_RANfunction_Definition__ric_ReportStyle_List),
	offsetof(struct E2SM_gNB_NRT_RANfunction_Definition__ric_ReportStyle_List, _asn_ctx),
	0,	/* XER encoding is XMLDelimitedItemList */
};
static /* Use -fall-defs-global to expose */
asn_TYPE_descriptor_t asn_DEF_ric_ReportStyle_List_5 = {
	"ric-ReportStyle-List",
	"ric-ReportStyle-List",
	&asn_OP_SEQUENCE_OF,
	asn_DEF_ric_ReportStyle_List_tags_5,
	sizeof(asn_DEF_ric_ReportStyle_List_tags_5)
		/sizeof(asn_DEF_ric_ReportStyle_List_tags_5[0]) - 1, /* 1 */
	asn_DEF_ric_ReportStyle_List_tags_5,	/* Same as above */
	sizeof(asn_DEF_ric_ReportStyle_List_tags_5)
		/sizeof(asn_DEF_ric_ReportStyle_List_tags_5[0]), /* 2 */
	{ 0, &asn_PER_type_ric_ReportStyle_List_constr_5, SEQUENCE_OF_constraint },
	asn_MBR_ric_ReportStyle_List_5,
	1,	/* Single element */
	&asn_SPC_ric_ReportStyle_List_specs_5	/* Additional specs */
};

static asn_TYPE_member_t asn_MBR_ric_InsertStyle_List_7[] = {
	{ ATF_POINTER, 0, 0,
		(ASN_TAG_CLASS_UNIVERSAL | (16 << 2)),
		0,
		&asn_DEF_RIC_InsertStyle_List,
		0,
		{ 0, 0, 0 },
		0, 0, /* No default value */
		""
		},
};
static const ber_tlv_tag_t asn_DEF_ric_InsertStyle_List_tags_7[] = {
	(ASN_TAG_CLASS_CONTEXT | (3 << 2)),
	(ASN_TAG_CLASS_UNIVERSAL | (16 << 2))
};
static asn_SET_OF_specifics_t asn_SPC_ric_InsertStyle_List_specs_7 = {
	sizeof(struct E2SM_gNB_NRT_RANfunction_Definition__ric_InsertStyle_List),
	offsetof(struct E2SM_gNB_NRT_RANfunction_Definition__ric_InsertStyle_List, _asn_ctx),
	0,	/* XER encoding is XMLDelimitedItemList */
};
static /* Use -fall-defs-global to expose */
asn_TYPE_descriptor_t asn_DEF_ric_InsertStyle_List_7 = {
	"ric-InsertStyle-List",
	"ric-InsertStyle-List",
	&asn_OP_SEQUENCE_OF,
	asn_DEF_ric_InsertStyle_List_tags_7,
	sizeof(asn_DEF_ric_InsertStyle_List_tags_7)
		/sizeof(asn_DEF_ric_InsertStyle_List_tags_7[0]) - 1, /* 1 */
	asn_DEF_ric_InsertStyle_List_tags_7,	/* Same as above */
	sizeof(asn_DEF_ric_InsertStyle_List_tags_7)
		/sizeof(asn_DEF_ric_InsertStyle_List_tags_7[0]), /* 2 */
	{ 0, &asn_PER_type_ric_InsertStyle_List_constr_7, SEQUENCE_OF_constraint },
	asn_MBR_ric_InsertStyle_List_7,
	1,	/* Single element */
	&asn_SPC_ric_InsertStyle_List_specs_7	/* Additional specs */
};

static asn_TYPE_member_t asn_MBR_ric_ControlStyle_List_9[] = {
	{ ATF_POINTER, 0, 0,
		(ASN_TAG_CLASS_UNIVERSAL | (16 << 2)),
		0,
		&asn_DEF_RIC_ControlStyle_List,
		0,
		{ 0, 0, 0 },
		0, 0, /* No default value */
		""
		},
};
static const ber_tlv_tag_t asn_DEF_ric_ControlStyle_List_tags_9[] = {
	(ASN_TAG_CLASS_CONTEXT | (4 << 2)),
	(ASN_TAG_CLASS_UNIVERSAL | (16 << 2))
};
static asn_SET_OF_specifics_t asn_SPC_ric_ControlStyle_List_specs_9 = {
	sizeof(struct E2SM_gNB_NRT_RANfunction_Definition__ric_ControlStyle_List),
	offsetof(struct E2SM_gNB_NRT_RANfunction_Definition__ric_ControlStyle_List, _asn_ctx),
	0,	/* XER encoding is XMLDelimitedItemList */
};
static /* Use -fall-defs-global to expose */
asn_TYPE_descriptor_t asn_DEF_ric_ControlStyle_List_9 = {
	"ric-ControlStyle-List",
	"ric-ControlStyle-List",
	&asn_OP_SEQUENCE_OF,
	asn_DEF_ric_ControlStyle_List_tags_9,
	sizeof(asn_DEF_ric_ControlStyle_List_tags_9)
		/sizeof(asn_DEF_ric_ControlStyle_List_tags_9[0]) - 1, /* 1 */
	asn_DEF_ric_ControlStyle_List_tags_9,	/* Same as above */
	sizeof(asn_DEF_ric_ControlStyle_List_tags_9)
		/sizeof(asn_DEF_ric_ControlStyle_List_tags_9[0]), /* 2 */
	{ 0, &asn_PER_type_ric_ControlStyle_List_constr_9, SEQUENCE_OF_constraint },
	asn_MBR_ric_ControlStyle_List_9,
	1,	/* Single element */
	&asn_SPC_ric_ControlStyle_List_specs_9	/* Additional specs */
};

static asn_TYPE_member_t asn_MBR_ric_PolicyStyle_List_11[] = {
	{ ATF_POINTER, 0, 0,
		(ASN_TAG_CLASS_UNIVERSAL | (16 << 2)),
		0,
		&asn_DEF_RIC_PolicyStyle_List,
		0,
		{ 0, 0, 0 },
		0, 0, /* No default value */
		""
		},
};
static const ber_tlv_tag_t asn_DEF_ric_PolicyStyle_List_tags_11[] = {
	(ASN_TAG_CLASS_CONTEXT | (5 << 2)),
	(ASN_TAG_CLASS_UNIVERSAL | (16 << 2))
};
static asn_SET_OF_specifics_t asn_SPC_ric_PolicyStyle_List_specs_11 = {
	sizeof(struct E2SM_gNB_NRT_RANfunction_Definition__ric_PolicyStyle_List),
	offsetof(struct E2SM_gNB_NRT_RANfunction_Definition__ric_PolicyStyle_List, _asn_ctx),
	0,	/* XER encoding is XMLDelimitedItemList */
};
static /* Use -fall-defs-global to expose */
asn_TYPE_descriptor_t asn_DEF_ric_PolicyStyle_List_11 = {
	"ric-PolicyStyle-List",
	"ric-PolicyStyle-List",
	&asn_OP_SEQUENCE_OF,
	asn_DEF_ric_PolicyStyle_List_tags_11,
	sizeof(asn_DEF_ric_PolicyStyle_List_tags_11)
		/sizeof(asn_DEF_ric_PolicyStyle_List_tags_11[0]) - 1, /* 1 */
	asn_DEF_ric_PolicyStyle_List_tags_11,	/* Same as above */
	sizeof(asn_DEF_ric_PolicyStyle_List_tags_11)
		/sizeof(asn_DEF_ric_PolicyStyle_List_tags_11[0]), /* 2 */
	{ 0, &asn_PER_type_ric_PolicyStyle_List_constr_11, SEQUENCE_OF_constraint },
	asn_MBR_ric_PolicyStyle_List_11,
	1,	/* Single element */
	&asn_SPC_ric_PolicyStyle_List_specs_11	/* Additional specs */
};

static asn_TYPE_member_t asn_MBR_E2SM_gNB_NRT_RANfunction_Definition_1[] = {
	{ ATF_NOFLAGS, 0, offsetof(struct E2SM_gNB_NRT_RANfunction_Definition, ranFunction_Name),
		(ASN_TAG_CLASS_CONTEXT | (0 << 2)),
		-1,	/* IMPLICIT tag at current level */
		&asn_DEF_RANfunction_Name,
		0,
		{ 0, 0, 0 },
		0, 0, /* No default value */
		"ranFunction-Name"
		},
	{ ATF_POINTER, 5, offsetof(struct E2SM_gNB_NRT_RANfunction_Definition, ric_EventTriggerStyle_List),
		(ASN_TAG_CLASS_CONTEXT | (1 << 2)),
		0,
		&asn_DEF_ric_EventTriggerStyle_List_3,
		0,
		{ 0, &asn_PER_memb_ric_EventTriggerStyle_List_constr_3,  memb_ric_EventTriggerStyle_List_constraint_1 },
		0, 0, /* No default value */
		"ric-EventTriggerStyle-List"
		},
	{ ATF_POINTER, 4, offsetof(struct E2SM_gNB_NRT_RANfunction_Definition, ric_ReportStyle_List),
		(ASN_TAG_CLASS_CONTEXT | (2 << 2)),
		0,
		&asn_DEF_ric_ReportStyle_List_5,
		0,
		{ 0, &asn_PER_memb_ric_ReportStyle_List_constr_5,  memb_ric_ReportStyle_List_constraint_1 },
		0, 0, /* No default value */
		"ric-ReportStyle-List"
		},
	{ ATF_POINTER, 3, offsetof(struct E2SM_gNB_NRT_RANfunction_Definition, ric_InsertStyle_List),
		(ASN_TAG_CLASS_CONTEXT | (3 << 2)),
		0,
		&asn_DEF_ric_InsertStyle_List_7,
		0,
		{ 0, &asn_PER_memb_ric_InsertStyle_List_constr_7,  memb_ric_InsertStyle_List_constraint_1 },
		0, 0, /* No default value */
		"ric-InsertStyle-List"
		},
	{ ATF_POINTER, 2, offsetof(struct E2SM_gNB_NRT_RANfunction_Definition, ric_ControlStyle_List),
		(ASN_TAG_CLASS_CONTEXT | (4 << 2)),
		0,
		&asn_DEF_ric_ControlStyle_List_9,
		0,
		{ 0, &asn_PER_memb_ric_ControlStyle_List_constr_9,  memb_ric_ControlStyle_List_constraint_1 },
		0, 0, /* No default value */
		"ric-ControlStyle-List"
		},
	{ ATF_POINTER, 1, offsetof(struct E2SM_gNB_NRT_RANfunction_Definition, ric_PolicyStyle_List),
		(ASN_TAG_CLASS_CONTEXT | (5 << 2)),
		0,
		&asn_DEF_ric_PolicyStyle_List_11,
		0,
		{ 0, &asn_PER_memb_ric_PolicyStyle_List_constr_11,  memb_ric_PolicyStyle_List_constraint_1 },
		0, 0, /* No default value */
		"ric-PolicyStyle-List"
		},
};
static const int asn_MAP_E2SM_gNB_NRT_RANfunction_Definition_oms_1[] = { 1, 2, 3, 4, 5 };
static const ber_tlv_tag_t asn_DEF_E2SM_gNB_NRT_RANfunction_Definition_tags_1[] = {
	(ASN_TAG_CLASS_UNIVERSAL | (16 << 2))
};
static const asn_TYPE_tag2member_t asn_MAP_E2SM_gNB_NRT_RANfunction_Definition_tag2el_1[] = {
    { (ASN_TAG_CLASS_CONTEXT | (0 << 2)), 0, 0, 0 }, /* ranFunction-Name */
    { (ASN_TAG_CLASS_CONTEXT | (1 << 2)), 1, 0, 0 }, /* ric-EventTriggerStyle-List */
    { (ASN_TAG_CLASS_CONTEXT | (2 << 2)), 2, 0, 0 }, /* ric-ReportStyle-List */
    { (ASN_TAG_CLASS_CONTEXT | (3 << 2)), 3, 0, 0 }, /* ric-InsertStyle-List */
    { (ASN_TAG_CLASS_CONTEXT | (4 << 2)), 4, 0, 0 }, /* ric-ControlStyle-List */
    { (ASN_TAG_CLASS_CONTEXT | (5 << 2)), 5, 0, 0 } /* ric-PolicyStyle-List */
};
static asn_SEQUENCE_specifics_t asn_SPC_E2SM_gNB_NRT_RANfunction_Definition_specs_1 = {
	sizeof(struct E2SM_gNB_NRT_RANfunction_Definition),
	offsetof(struct E2SM_gNB_NRT_RANfunction_Definition, _asn_ctx),
	asn_MAP_E2SM_gNB_NRT_RANfunction_Definition_tag2el_1,
	6,	/* Count of tags in the map */
	asn_MAP_E2SM_gNB_NRT_RANfunction_Definition_oms_1,	/* Optional members */
	5, 0,	/* Root/Additions */
	6,	/* First extension addition */
};
asn_TYPE_descriptor_t asn_DEF_E2SM_gNB_NRT_RANfunction_Definition = {
	"E2SM-gNB-NRT-RANfunction-Definition",
	"E2SM-gNB-NRT-RANfunction-Definition",
	&asn_OP_SEQUENCE,
	asn_DEF_E2SM_gNB_NRT_RANfunction_Definition_tags_1,
	sizeof(asn_DEF_E2SM_gNB_NRT_RANfunction_Definition_tags_1)
		/sizeof(asn_DEF_E2SM_gNB_NRT_RANfunction_Definition_tags_1[0]), /* 1 */
	asn_DEF_E2SM_gNB_NRT_RANfunction_Definition_tags_1,	/* Same as above */
	sizeof(asn_DEF_E2SM_gNB_NRT_RANfunction_Definition_tags_1)
		/sizeof(asn_DEF_E2SM_gNB_NRT_RANfunction_Definition_tags_1[0]), /* 1 */
	{ 0, 0, SEQUENCE_constraint },
	asn_MBR_E2SM_gNB_NRT_RANfunction_Definition_1,
	6,	/* Elements count */
	&asn_SPC_E2SM_gNB_NRT_RANfunction_Definition_specs_1	/* Additional specs */
};

