/*
 * Copyright 2019 AT&T Intellectual Property
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/*
 * This source code is part of the near-RT RIC (RAN Intelligent Controller)
 * platform project (RICP).
 */



/*
 * Generated by asn1c-0.9.29 (http://lionet.info/asn1c)
 * From ASN.1 module "X2AP-IEs"
 * 	found in "../../asnFiles/X2AP-IEs.asn"
 * 	`asn1c -fcompound-names -fincludes-quoted -fno-include-deps -findirect-choice -gen-PER -no-gen-OER -D.`
 */

#include "E-RABUsageReport-Item.h"

#include "ProtocolExtensionContainer.h"
static int
usageCountUL_4_constraint(const asn_TYPE_descriptor_t *td, const void *sptr,
			asn_app_constraint_failed_f *ctfailcb, void *app_key) {
	
	if(!sptr) {
		ASN__CTFAIL(app_key, td, sptr,
			"%s: value not given (%s:%d)",
			td->name, __FILE__, __LINE__);
		return -1;
	}
	
	
	/* Constraint check succeeded */
	return 0;
}

/*
 * This type is implemented using NativeInteger,
 * so here we adjust the DEF accordingly.
 */
static int
usageCountDL_5_constraint(const asn_TYPE_descriptor_t *td, const void *sptr,
			asn_app_constraint_failed_f *ctfailcb, void *app_key) {
	
	if(!sptr) {
		ASN__CTFAIL(app_key, td, sptr,
			"%s: value not given (%s:%d)",
			td->name, __FILE__, __LINE__);
		return -1;
	}
	
	
	/* Constraint check succeeded */
	return 0;
}

/*
 * This type is implemented using NativeInteger,
 * so here we adjust the DEF accordingly.
 */
static int
memb_startTimeStamp_constraint_1(const asn_TYPE_descriptor_t *td, const void *sptr,
			asn_app_constraint_failed_f *ctfailcb, void *app_key) {
	const OCTET_STRING_t *st = (const OCTET_STRING_t *)sptr;
	size_t size;
	
	if(!sptr) {
		ASN__CTFAIL(app_key, td, sptr,
			"%s: value not given (%s:%d)",
			td->name, __FILE__, __LINE__);
		return -1;
	}
	
	size = st->size;
	
	if((size == 4)) {
		/* Constraint check succeeded */
		return 0;
	} else {
		ASN__CTFAIL(app_key, td, sptr,
			"%s: constraint failed (%s:%d)",
			td->name, __FILE__, __LINE__);
		return -1;
	}
}

static int
memb_endTimeStamp_constraint_1(const asn_TYPE_descriptor_t *td, const void *sptr,
			asn_app_constraint_failed_f *ctfailcb, void *app_key) {
	const OCTET_STRING_t *st = (const OCTET_STRING_t *)sptr;
	size_t size;
	
	if(!sptr) {
		ASN__CTFAIL(app_key, td, sptr,
			"%s: value not given (%s:%d)",
			td->name, __FILE__, __LINE__);
		return -1;
	}
	
	size = st->size;
	
	if((size == 4)) {
		/* Constraint check succeeded */
		return 0;
	} else {
		ASN__CTFAIL(app_key, td, sptr,
			"%s: constraint failed (%s:%d)",
			td->name, __FILE__, __LINE__);
		return -1;
	}
}

static int
memb_usageCountUL_constraint_1(const asn_TYPE_descriptor_t *td, const void *sptr,
			asn_app_constraint_failed_f *ctfailcb, void *app_key) {
	
	if(!sptr) {
		ASN__CTFAIL(app_key, td, sptr,
			"%s: value not given (%s:%d)",
			td->name, __FILE__, __LINE__);
		return -1;
	}
	
	
	/* Constraint check succeeded */
	return 0;
}

static int
memb_usageCountDL_constraint_1(const asn_TYPE_descriptor_t *td, const void *sptr,
			asn_app_constraint_failed_f *ctfailcb, void *app_key) {
	
	if(!sptr) {
		ASN__CTFAIL(app_key, td, sptr,
			"%s: value not given (%s:%d)",
			td->name, __FILE__, __LINE__);
		return -1;
	}
	
	
	/* Constraint check succeeded */
	return 0;
}

static asn_per_constraints_t asn_PER_type_usageCountUL_constr_4 CC_NOTUSED = {
	{ APC_CONSTRAINED,	 32, -1,  0,  4294967295 }	/* (0..4294967295) */,
	{ APC_UNCONSTRAINED,	-1, -1,  0,  0 },
	0, 0	/* No PER value map */
};
static asn_per_constraints_t asn_PER_type_usageCountDL_constr_5 CC_NOTUSED = {
	{ APC_CONSTRAINED,	 32, -1,  0,  4294967295 }	/* (0..4294967295) */,
	{ APC_UNCONSTRAINED,	-1, -1,  0,  0 },
	0, 0	/* No PER value map */
};
static asn_per_constraints_t asn_PER_memb_startTimeStamp_constr_2 CC_NOTUSED = {
	{ APC_UNCONSTRAINED,	-1, -1,  0,  0 },
	{ APC_CONSTRAINED,	 0,  0,  4,  4 }	/* (SIZE(4..4)) */,
	0, 0	/* No PER value map */
};
static asn_per_constraints_t asn_PER_memb_endTimeStamp_constr_3 CC_NOTUSED = {
	{ APC_UNCONSTRAINED,	-1, -1,  0,  0 },
	{ APC_CONSTRAINED,	 0,  0,  4,  4 }	/* (SIZE(4..4)) */,
	0, 0	/* No PER value map */
};
static asn_per_constraints_t asn_PER_memb_usageCountUL_constr_4 CC_NOTUSED = {
	{ APC_CONSTRAINED,	 32, -1,  0,  4294967295 }	/* (0..4294967295) */,
	{ APC_UNCONSTRAINED,	-1, -1,  0,  0 },
	0, 0	/* No PER value map */
};
static asn_per_constraints_t asn_PER_memb_usageCountDL_constr_5 CC_NOTUSED = {
	{ APC_CONSTRAINED,	 32, -1,  0,  4294967295 }	/* (0..4294967295) */,
	{ APC_UNCONSTRAINED,	-1, -1,  0,  0 },
	0, 0	/* No PER value map */
};
static const asn_INTEGER_specifics_t asn_SPC_usageCountUL_specs_4 = {
	0,	0,	0,	0,	0,
	0,	/* Native long size */
	1	/* Unsigned representation */
};
static const ber_tlv_tag_t asn_DEF_usageCountUL_tags_4[] = {
	(ASN_TAG_CLASS_CONTEXT | (2 << 2)),
	(ASN_TAG_CLASS_UNIVERSAL | (2 << 2))
};
static /* Use -fall-defs-global to expose */
asn_TYPE_descriptor_t asn_DEF_usageCountUL_4 = {
	"usageCountUL",
	"usageCountUL",
	&asn_OP_NativeInteger,
	asn_DEF_usageCountUL_tags_4,
	sizeof(asn_DEF_usageCountUL_tags_4)
		/sizeof(asn_DEF_usageCountUL_tags_4[0]) - 1, /* 1 */
	asn_DEF_usageCountUL_tags_4,	/* Same as above */
	sizeof(asn_DEF_usageCountUL_tags_4)
		/sizeof(asn_DEF_usageCountUL_tags_4[0]), /* 2 */
	{ 0, &asn_PER_type_usageCountUL_constr_4, usageCountUL_4_constraint },
	0, 0,	/* No members */
	&asn_SPC_usageCountUL_specs_4	/* Additional specs */
};

static const asn_INTEGER_specifics_t asn_SPC_usageCountDL_specs_5 = {
	0,	0,	0,	0,	0,
	0,	/* Native long size */
	1	/* Unsigned representation */
};
static const ber_tlv_tag_t asn_DEF_usageCountDL_tags_5[] = {
	(ASN_TAG_CLASS_CONTEXT | (3 << 2)),
	(ASN_TAG_CLASS_UNIVERSAL | (2 << 2))
};
static /* Use -fall-defs-global to expose */
asn_TYPE_descriptor_t asn_DEF_usageCountDL_5 = {
	"usageCountDL",
	"usageCountDL",
	&asn_OP_NativeInteger,
	asn_DEF_usageCountDL_tags_5,
	sizeof(asn_DEF_usageCountDL_tags_5)
		/sizeof(asn_DEF_usageCountDL_tags_5[0]) - 1, /* 1 */
	asn_DEF_usageCountDL_tags_5,	/* Same as above */
	sizeof(asn_DEF_usageCountDL_tags_5)
		/sizeof(asn_DEF_usageCountDL_tags_5[0]), /* 2 */
	{ 0, &asn_PER_type_usageCountDL_constr_5, usageCountDL_5_constraint },
	0, 0,	/* No members */
	&asn_SPC_usageCountDL_specs_5	/* Additional specs */
};

asn_TYPE_member_t asn_MBR_E_RABUsageReport_Item_1[] = {
	{ ATF_NOFLAGS, 0, offsetof(struct E_RABUsageReport_Item, startTimeStamp),
		(ASN_TAG_CLASS_CONTEXT | (0 << 2)),
		-1,	/* IMPLICIT tag at current level */
		&asn_DEF_OCTET_STRING,
		0,
		{ 0, &asn_PER_memb_startTimeStamp_constr_2,  memb_startTimeStamp_constraint_1 },
		0, 0, /* No default value */
		"startTimeStamp"
		},
	{ ATF_NOFLAGS, 0, offsetof(struct E_RABUsageReport_Item, endTimeStamp),
		(ASN_TAG_CLASS_CONTEXT | (1 << 2)),
		-1,	/* IMPLICIT tag at current level */
		&asn_DEF_OCTET_STRING,
		0,
		{ 0, &asn_PER_memb_endTimeStamp_constr_3,  memb_endTimeStamp_constraint_1 },
		0, 0, /* No default value */
		"endTimeStamp"
		},
	{ ATF_NOFLAGS, 0, offsetof(struct E_RABUsageReport_Item, usageCountUL),
		(ASN_TAG_CLASS_CONTEXT | (2 << 2)),
		-1,	/* IMPLICIT tag at current level */
		&asn_DEF_usageCountUL_4,
		0,
		{ 0, &asn_PER_memb_usageCountUL_constr_4,  memb_usageCountUL_constraint_1 },
		0, 0, /* No default value */
		"usageCountUL"
		},
	{ ATF_NOFLAGS, 0, offsetof(struct E_RABUsageReport_Item, usageCountDL),
		(ASN_TAG_CLASS_CONTEXT | (3 << 2)),
		-1,	/* IMPLICIT tag at current level */
		&asn_DEF_usageCountDL_5,
		0,
		{ 0, &asn_PER_memb_usageCountDL_constr_5,  memb_usageCountDL_constraint_1 },
		0, 0, /* No default value */
		"usageCountDL"
		},
	{ ATF_POINTER, 1, offsetof(struct E_RABUsageReport_Item, iE_Extensions),
		(ASN_TAG_CLASS_CONTEXT | (4 << 2)),
		-1,	/* IMPLICIT tag at current level */
		&asn_DEF_ProtocolExtensionContainer_170P141,
		0,
		{ 0, 0, 0 },
		0, 0, /* No default value */
		"iE-Extensions"
		},
};
static const int asn_MAP_E_RABUsageReport_Item_oms_1[] = { 4 };
static const ber_tlv_tag_t asn_DEF_E_RABUsageReport_Item_tags_1[] = {
	(ASN_TAG_CLASS_UNIVERSAL | (16 << 2))
};
static const asn_TYPE_tag2member_t asn_MAP_E_RABUsageReport_Item_tag2el_1[] = {
    { (ASN_TAG_CLASS_CONTEXT | (0 << 2)), 0, 0, 0 }, /* startTimeStamp */
    { (ASN_TAG_CLASS_CONTEXT | (1 << 2)), 1, 0, 0 }, /* endTimeStamp */
    { (ASN_TAG_CLASS_CONTEXT | (2 << 2)), 2, 0, 0 }, /* usageCountUL */
    { (ASN_TAG_CLASS_CONTEXT | (3 << 2)), 3, 0, 0 }, /* usageCountDL */
    { (ASN_TAG_CLASS_CONTEXT | (4 << 2)), 4, 0, 0 } /* iE-Extensions */
};
asn_SEQUENCE_specifics_t asn_SPC_E_RABUsageReport_Item_specs_1 = {
	sizeof(struct E_RABUsageReport_Item),
	offsetof(struct E_RABUsageReport_Item, _asn_ctx),
	asn_MAP_E_RABUsageReport_Item_tag2el_1,
	5,	/* Count of tags in the map */
	asn_MAP_E_RABUsageReport_Item_oms_1,	/* Optional members */
	1, 0,	/* Root/Additions */
	5,	/* First extension addition */
};
asn_TYPE_descriptor_t asn_DEF_E_RABUsageReport_Item = {
	"E-RABUsageReport-Item",
	"E-RABUsageReport-Item",
	&asn_OP_SEQUENCE,
	asn_DEF_E_RABUsageReport_Item_tags_1,
	sizeof(asn_DEF_E_RABUsageReport_Item_tags_1)
		/sizeof(asn_DEF_E_RABUsageReport_Item_tags_1[0]), /* 1 */
	asn_DEF_E_RABUsageReport_Item_tags_1,	/* Same as above */
	sizeof(asn_DEF_E_RABUsageReport_Item_tags_1)
		/sizeof(asn_DEF_E_RABUsageReport_Item_tags_1[0]), /* 1 */
	{ 0, 0, SEQUENCE_constraint },
	asn_MBR_E_RABUsageReport_Item_1,
	5,	/* Elements count */
	&asn_SPC_E_RABUsageReport_Item_specs_1	/* Additional specs */
};

