/*
 * Copyright 2019 AT&T Intellectual Property
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/*
 * This source code is part of the near-RT RIC (RAN Intelligent Controller)
 * platform project (RICP).
 */



/*
 * Generated by asn1c-0.9.29 (http://lionet.info/asn1c)
 * From ASN.1 module "X2AP-PDU-Contents"
 * 	found in "../../asnFiles/X2AP-PDU-Contents.asn"
 * 	`asn1c -fcompound-names -fincludes-quoted -fno-include-deps -findirect-choice -gen-PER -no-gen-OER -D.`
 */

#ifndef	_ServedNRCell_Information_H_
#define	_ServedNRCell_Information_H_


#include "asn_application.h"

/* Including external dependencies */
#include "NRPCI.h"
#include "NRCGI.h"
#include "FiveGS-TAC.h"
#include "TAC.h"
#include "BroadcastPLMNs-Item.h"
#include "OCTET_STRING.h"
#include "constr_CHOICE.h"
#include "constr_SEQUENCE.h"

#ifdef __cplusplus
extern "C" {
#endif

/* Dependencies */
typedef enum ServedNRCell_Information__nrModeInfo_PR {
	ServedNRCell_Information__nrModeInfo_PR_NOTHING,	/* No components present */
	ServedNRCell_Information__nrModeInfo_PR_fdd,
	ServedNRCell_Information__nrModeInfo_PR_tdd
	/* Extensions may appear below */
	
} ServedNRCell_Information__nrModeInfo_PR;

/* Forward declarations */
struct ProtocolExtensionContainer;
struct FDD_InfoServedNRCell_Information;
struct TDD_InfoServedNRCell_Information;

/* ServedNRCell-Information */
typedef struct ServedNRCell_Information {
	NRPCI_t	 nrpCI;
	NRCGI_t	 nrCellID;
	FiveGS_TAC_t	*fiveGS_TAC;	/* OPTIONAL */
	TAC_t	*configured_TAC;	/* OPTIONAL */
	BroadcastPLMNs_Item_t	 broadcastPLMNs;
	struct ServedNRCell_Information__nrModeInfo {
		ServedNRCell_Information__nrModeInfo_PR present;
		union ServedNRCell_Information__nrModeInfo_u {
			struct FDD_InfoServedNRCell_Information	*fdd;
			struct TDD_InfoServedNRCell_Information	*tdd;
			/*
			 * This type is extensible,
			 * possible extensions are below.
			 */
		} choice;
		
		/* Context for parsing across buffer boundaries */
		asn_struct_ctx_t _asn_ctx;
	} nrModeInfo;
	OCTET_STRING_t	 measurementTimingConfiguration;
	struct ProtocolExtensionContainer	*iE_Extensions;	/* OPTIONAL */
	/*
	 * This type is extensible,
	 * possible extensions are below.
	 */
	
	/* Context for parsing across buffer boundaries */
	asn_struct_ctx_t _asn_ctx;
} ServedNRCell_Information_t;

/* Implementation */
extern asn_TYPE_descriptor_t asn_DEF_ServedNRCell_Information;
extern asn_SEQUENCE_specifics_t asn_SPC_ServedNRCell_Information_specs_1;
extern asn_TYPE_member_t asn_MBR_ServedNRCell_Information_1[8];

#ifdef __cplusplus
}
#endif

#endif	/* _ServedNRCell_Information_H_ */
#include "asn_internal.h"
