/*
 * Copyright 2019 AT&T Intellectual Property
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/*
 * This source code is part of the near-RT RIC (RAN Intelligent Controller)
 * platform project (RICP).
 */



/*
 * Generated by asn1c-0.9.29 (http://lionet.info/asn1c)
 * From ASN.1 module "X2AP-PDU-Contents"
 * 	found in "../../asnFiles/X2AP-PDU-Contents.asn"
 * 	`asn1c -fcompound-names -fincludes-quoted -fno-include-deps -findirect-choice -gen-PER -no-gen-OER -D.`
 */

#ifndef	_UE_ContextInformationRetrieve_H_
#define	_UE_ContextInformationRetrieve_H_


#include "asn_application.h"

/* Including external dependencies */
#include "UE-S1AP-ID.h"
#include "UESecurityCapabilities.h"
#include "AS-SecurityInformation.h"
#include "UEAggregateMaximumBitRate.h"
#include "SubscriberProfileIDforRFP.h"
#include "E-RABs-ToBeSetup-ListRetrieve.h"
#include "RRC-Context.h"
#include "ManagementBasedMDTallowed.h"
#include "constr_SEQUENCE.h"

#ifdef __cplusplus
extern "C" {
#endif

/* Forward declarations */
struct HandoverRestrictionList;
struct LocationReportingInformation;
struct MDTPLMNList;
struct ProtocolExtensionContainer;

/* UE-ContextInformationRetrieve */
typedef struct UE_ContextInformationRetrieve {
	UE_S1AP_ID_t	 mME_UE_S1AP_ID;
	UESecurityCapabilities_t	 uESecurityCapabilities;
	AS_SecurityInformation_t	 aS_SecurityInformation;
	UEAggregateMaximumBitRate_t	 uEaggregateMaximumBitRate;
	SubscriberProfileIDforRFP_t	*subscriberProfileIDforRFP;	/* OPTIONAL */
	E_RABs_ToBeSetup_ListRetrieve_t	 e_RABs_ToBeSetup_ListRetrieve;
	RRC_Context_t	 rRC_Context;
	struct HandoverRestrictionList	*handoverRestrictionList;	/* OPTIONAL */
	struct LocationReportingInformation	*locationReportingInformation;	/* OPTIONAL */
	ManagementBasedMDTallowed_t	*managBasedMDTallowed;	/* OPTIONAL */
	struct MDTPLMNList	*managBasedMDTPLMNList;	/* OPTIONAL */
	struct ProtocolExtensionContainer	*iE_Extensions;	/* OPTIONAL */
	/*
	 * This type is extensible,
	 * possible extensions are below.
	 */
	
	/* Context for parsing across buffer boundaries */
	asn_struct_ctx_t _asn_ctx;
} UE_ContextInformationRetrieve_t;

/* Implementation */
extern asn_TYPE_descriptor_t asn_DEF_UE_ContextInformationRetrieve;

#ifdef __cplusplus
}
#endif

#endif	/* _UE_ContextInformationRetrieve_H_ */
#include "asn_internal.h"
